# Manifests for rpm-ostree based Fedora variants

This is the configuration needed to create
[rpm-ostree](https://coreos.github.io/rpm-ostree/) based variants of Fedora.
Each variant is described in a YAML
[treefile](https://coreos.github.io/rpm-ostree/treefile/) which is then used by
rpm-ostree to compose an ostree commit with the package requested.

**Note:** This repository's upstream resides [here](https://pagure.io/workstation-ostree-config.git) this fork's purpose is for testing and preparation of a proper sway ostree spin. This README is slightly modified from what's upstream to reflect that. The goal and purpose is to create 'test' builds with [OstreeNativeContainer](https://fedoraproject.org/wiki/Changes/OstreeNativeContainer) that get propagated to our *production* ostree testing repo.

In the Fedora infrastructure, this happens via
[pungi](https://pagure.io/pungi-fedora) with
[Lorax](https://github.com/weldr/lorax)
([templates](https://pagure.io/fedora-lorax-templates)).

## Fedora Silverblue

- Website: https://silverblue.fedoraproject.org/ ([sources](https://github.com/fedora-silverblue/silverblue-site))
- Documentation: https://docs.fedoraproject.org/en-US/fedora-silverblue/ ([sources](https://github.com/fedora-silverblue/silverblue-docs))
- Issue tracker: https://github.com/fedora-silverblue/issue-tracker/issues

## Fedora Kinoite

- Website: https://kinoite.fedoraproject.org/ ([sources](https://pagure.io/fedora-kde/kinoite-site))
- Documentation: https://docs.fedoraproject.org/en-US/fedora-kinoite/ ([sources](https://pagure.io/fedora-kde/kinoite-docs))
- Issue tracker: https://pagure.io/fedora-kde/SIG/issues

## Fedora Sericea (Sway)

- Website: TBD ([sources](https://pagure.io/fedora-kde/kinoite-site))
- Documentation: TBD ~~([sources]())~~
- Issue tracker: https://gitlab.com/fedora/sigs/sway/SIG

## Building

Instructions to perform a local build of Sericea:

```
# Clone the config
git clone https://gitlab.com/fedora/sigs/sway/ostree-config.git && cd ostree-config

# Prepare directories
mkdir -p repo cache
ostree --repo=repo init --mode=archive

# Build (compose) the variant of your choice
sudo rpm-ostree compose tree --repo=repo fedora-sericea.yaml

# Update summary file
ostree summary --repo=repo --update
```

## Testing

Instructions to test the resulting build:

- First, serve the ostree repo using an HTTP server. You can use any static file server. For example using <https://github.com/TheWaWaR/simple-http-server>:

  ```
  simple-http-server --index --ip 192.168.122.1 --port 8000
  ```

- Then, on an already installed Silverblue system:

**Note:** test builds of rawhide at this time are currently hosted on a ostree repo. Every commit to the `rawhide-sway-spin` branch creates a new ostree commit and the resulting changes will slowly be propagated to the production tree.

```
# Add sway ostree remote
sudo ostree remote add sway-sig --no-gpg-verify https://sway-sig.kutara.io/ostree/

# Pin the currently deployed (and probably working) version
sudo ostree admin pin 0

# List refs from variant remote
sudo ostree remote refs sway-sig

# Switch to your variant
sudo rpm-ostree rebase sway-sig:fedora/rawhide/x86_64/sericea
# sudo rpm-ostree rebase sway-sig:fedora/37/x86_64/sericea
# sudo rpm-ostree rebase sway-sig:fedora/36/x86_64/sericea

# Reboot and test!
```

## Historical references

Building and testing instructions:

- https://dustymabe.com/2017/10/05/setting-up-an-atomic-host-build-server/
- https://dustymabe.com/2017/08/08/how-do-we-create-ostree-repos-and-artifacts-in-fedora/
- https://www.projectatomic.io/blog/2017/12/compose-custom-ostree/
- https://www.projectatomic.io/docs/compose-your-own-tree/

For some background, see:

- <https://fedoraproject.org/wiki/Workstation/AtomicWorkstation>
- <https://fedoraproject.org/wiki/Changes/WorkstationOstree>
- <https://fedoraproject.org/wiki/Changes/Silverblue>
- <https://fedoraproject.org/wiki/Changes/Fedora_Kinoite>

Note also this repo obsoletes https://pagure.io/atomic-ws
